package cap3

import "strings"

type AlgoType int

const (
    AlgoTypeRecursion AlgoType = iota
    AlgoTypeNoneRecursion
)

func DigitSlice2String(nums []uint8) string {
    zeroPrefix := true
    sb := strings.Builder{}
    for _, num := range nums {
        if zeroPrefix && num == 0 {
            continue
        } else {
            zeroPrefix = false
        }

        sb.WriteByte(num + 48)
    }

    return sb.String()
}
